atom
	proc
		Icon_State(t as text)
			if(t in icon_states(icon)){ icon_state=t; return TRUE;}
		Flick(t as text)
			if(t in icon_states(icon)){ flick(t,src); return TRUE;}
icon
	proc
		ResizeWithAspect(new_width,new_height,alignment)
			if(!new_width && !new_height) return src
			if(!new_width && new_height) new_width=new_height
			if(new_width && !new_height) new_height=new_width
			var{width=Width();height=Height()}
			if(!width||!height) return src
			var{testw=1;testh=1}
			if(width!=new_width) testw=(new_width/width)
			if(height!=new_height)testh=(new_height/height)
			if(!testw&&!testh) return src
			if(testw*height < new_height) Scale(round(width*testh),round(height*testh))
			else Scale(round(width*testw),round(height*testw))
			var{compx;compy}
			if(alignment==1) {compx=Width()-new_width;compy=Height()-new_height}
			if(alignment>1) {compx=(Width()-new_width)?(Width()-new_width)/2:0;compy=(Height()-new_height)?(Height()-new_height)/2:0}
			Crop(1+compx,1+compy,new_width+compx,new_height+compy)
			return src
// Associative list of [md5 values = Icon] for determining if the icon already exists
var/list/_flatIcons = new()
proc
	getFlatIcon(atom/A, dir, cache=1) // 1 = use cache, 2 = override cache, 0 = ignore cache
		var/list/layers = list() // Associative list of [overlay = layer]
		var/hash = "" // Hash of overlay combination
		var/atomDir = A.dir
		if(!dir) dir = SOUTH //A.dir // dir defaults to A's dir
		else A.dir = dir // Rotate atom to update overlays that inherit dir
		// Add the atom's icon itself
		if(A.icon)
			// Make a copy without pixel_x/y settings
			var/image/copy = image(icon=A.icon,icon_state=A.icon_state,layer=A.layer,dir=dir)
			layers[copy] = A.layer
		// Loop through the underlays, then overlays, sorting them into the layers list
		var
			list/process = A.underlays // Current list being processed
			processSubset=0 // Which list is being processed: 0 = underlays, 1 = overlays
			currentIndex=1 // index of 'current' in list being processed
			currentOverlay // Current overlay being sorted
			currentLayer // Calculated layer that overlay appears on (special case for FLOAT_LAYER)
			compareOverlay // The overlay that the current overlay is being compared against
			compareIndex // The index in the layers list of 'compare'
		while(TRUE)
			if(currentIndex<=process.len)
				currentOverlay = process[currentIndex]
				currentLayer = currentOverlay:layer
				if(currentLayer<0) // Special case for FLY_LAYER
					ASSERT(currentLayer > -1000)
					if(processSubset == 0) // Underlay
						currentLayer = A.layer+currentLayer/1000
					else // Overlay
						currentLayer = A.layer+(1000+currentLayer)/1000
				// Sort add into layers list
				for(compareIndex=1,compareIndex<=layers.len,compareIndex++)
					compareOverlay = layers[compareIndex]
					if(currentLayer < layers[compareOverlay]) // Associated value is the calculated layer
						layers.Insert(compareIndex,currentOverlay)
						layers[currentOverlay] = currentLayer
						break
				if(compareIndex>layers.len) // Reached end of list without inserting
					layers[currentOverlay]=currentLayer // Place at end
				currentIndex++
			if(currentIndex>process.len)
				if(processSubset == 0) // Switch to overlays
					currentIndex = 1
					processSubset = 1
					process = A.overlays
				else // All done
					break
		if(cache!=0) // If cache is NOT disabled
			// Create a hash value to represent this specific flattened icon
			for(var/I in layers)
				hash += "\ref[I:icon],[I:icon_state],[I:dir ? I:dir : dir],[I:pixel_x],[I:pixel_y];_;"
			hash=md5(hash)
			if(cache!=2) // If NOT overriding cache
				// Check if the icon has already been generated
				if((hash in _flatIcons) && _flatIcons[hash])
					// Icon already exists, just return that one
					A.dir = atomDir // Reset dir
					return _flatIcons[hash]
		var
			// We start with a blank canvas, otherwise some icon procs crash silently
			icon/flat = icon('_flat_Blank.dmi') // Final flattened icon
			icon/add // Icon of overlay being added
			// Set current dimensions of flattened icon
			flatX1=1
			flatX2=flat.Width()
			flatY1=1
			flatY2=flat.Height()
			// Dimensions of overlay being added
			addX1;addX2;addY1;addY2
		for(var/I in layers)
			if(I:icon)
				if(I:icon_state)
					// Has icon and state set
					add = icon(I:icon, I:icon_state, dir, 1, 0)
				else
					if(A.icon_state in icon_states(I:icon))
						// Inherits icon_state from atom
						add = icon(I:icon, A.icon_state, dir, 1, 0)
					else
						// Uses default state ("")
						add = icon(I:icon, "", dir, 1, 0)
			else if(I:icon_state)// Inherits icon from atom
				add = icon(A.icon, I:icon_state, dir, 1, 0)
			else// Unknown
				continue
			// Find the new dimensions of the flat icon to fit the added overlay
			addX1 = min(flatX1, I:pixel_x+1)
			addX2 = max(flatX2, I:pixel_x+add.Width())
			addY1 = min(flatY1, I:pixel_y+1)
			addY2 = max(flatY2, I:pixel_y+add.Height())
			if(addX1!=flatX1 || addX2!=flatX2 || addY1!=flatY1 || addY2!=flatY2)
				// Resize the flattened icon so the new icon fits
				flat.Crop(addX1-flatX1+1, addY1-flatY1+1, addX2-flatX1+1, addY2-flatY1+1)
				flatX1=addX1;flatX2=addX2
				flatY1=addY1;flatY2=addY2
			// Blend the overlay into the flattened icon
			flat.Blend(add,ICON_OVERLAY,I:pixel_x+2-flatX1,I:pixel_y+2-flatY1)
		if(cache!=0) // If cache is NOT disabled
			// Cache the generated icon in our list so we don't have to regenerate it
			_flatIcons[hash] = flat
		A.dir = atomDir // Reset dir
		return flat